// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "sbagence.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TIMER_ID 1
#define TIMER_INTERVAL 1000
#define DIE_CNT 60*60 // 1 hr

extern int Play(CWnd *parent,char *fn);

UINT PlayThread(LPVOID lpv)
{
  CChildView *p = (CChildView *)lpv;
  Play(p,p->afn);
  return 0;
}



/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
  m_iDieCnt = DIE_CNT;
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_WM_TIMER()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
}


#define FDT_OPEN 0
#define FDT_SAVE 1
BOOL FileDialog(OPENFILENAME *ofn,TCHAR *initialdir,DWORD flags,HWND owner,HINSTANCE hinst,TCHAR *filename,int maxlen,TCHAR *title,TCHAR *filter,TCHAR *defext,int dlgtype)
{
  if (!ofn->lStructSize) {
    ofn->lStructSize = sizeof(OPENFILENAME);
#ifndef _WIN32_WCE
    ofn->lpstrCustomFilter = (LPTSTR)NULL;
    ofn->nMaxCustFilter = 0L;
#endif
    ofn->nFilterIndex = 1L;
    //    ofn->nFileOffset = 0;
    //    ofn->nFileExtension = 0;
    //    ofn->lpstrDefExt = NULL;
  }

  ofn->hwndOwner = owner;
#ifndef _WIN32_WCE
  ofn->hInstance = hinst;
#endif
  ofn->lpstrFile = filename;
  ofn->nMaxFile = maxlen;

  ofn->Flags = flags;
  ofn->lpstrFilter = filter;
  ofn->lpstrInitialDir = initialdir;
  ofn->lpstrFileTitle = NULL;
  ofn->nMaxFileTitle = 0;
  ofn->lpstrTitle = title;
  ofn->lpstrDefExt = defext;

  if (dlgtype == FDT_OPEN)
    return GetOpenFileName(ofn);
  else
    return GetSaveFileName(ofn);
}

void CChildView::OnFileOpen() 
{
  OPENFILENAME ofn;
  ZeroMemory(&ofn,sizeof(ofn));
  TCHAR fn[MAX_PATH]=_T("\0");;
  TCHAR initialdir[MAX_PATH] = _T("SBaGen");
  if (FileDialog(&ofn,initialdir,
		 OFN_FILEMUSTEXIST|OFN_NODEREFERENCELINKS,
		 m_hWnd,AfxGetInstanceHandle(),fn,MAX_PATH,
		 _T("Open Prog Files"),_T("SBaGen Prog Files (*.sba)\0*.sba\0"),_T("SBaGen"),FDT_OPEN) && *fn) {
    WideCharToMultiByte(CP_ACP,0,fn,-1,afn,MAX_PATH,NULL,NULL);
    AfxBeginThread((AFX_THREADPROC)PlayThread,this);
  }
}

void CChildView::OnExit() 
{
  PostQuitMessage(0);
}

void CChildView::OnTimer(UINT nIDEvent) 
{
  if (--m_iDieCnt <= 0) {
    PostQuitMessage(0);
  }
  SystemIdleTimerReset();     // keep machine from suspending
}

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
  if (CWnd ::OnCreate(lpCreateStruct) == -1)
    return -1;
	
  SetTimer(TIMER_ID,TIMER_INTERVAL,NULL);
	
  return 0;
}
